include: 'trigger.yml'

default:
  image: linaro/jenkins-amd64-debian:bullseye

variables:
  CONFIG_REPO_URL:
    value: 'https://git.linaro.org/landing-teams/working/qualcomm/configs.git'
    description: ''
  CONFIG_BRANCH:
    value: 'master'
    description: ''
  KERNEL_REPO_URL:
    value: 'git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git'
    description: ''
  KERNEL_TAGS:
    value: 'v4. v5. v6.'
    description: ''
  KERNEL_CI_REPO_URL:
    value: 'https://git.linaro.org/landing-teams/working/qualcomm/kernel.git'
    description: ''
  RERERE_REPO_URL:
    value: 'https://git.linaro.org/landing-teams/working/qualcomm/automerge-rrcache.git'
    description: ''
  RERERE_BRANCH:
    value: 'master'
    description: ''

  CONFIG_REPO_DIR: 'configs'
  AUTOMERGE_PROJECT_PATH: 'lt-qcom-gitlab-ci/linux-automerge/linux-automerge'

  CONFIG_SUMS: '$CI_PROJECT_DIR/automerge-ci.sums'
  CONFIG_DIFF_SUMS: '$CI_PROJECT_DIR/automerge-ci-diff.sums'

  RERERE_SUM: '$CI_PROJECT_DIR/rrcache.sum'
  RERERE_DIFF_SUM: '$CI_PROJECT_DIR/rrcache-diff.sum'

  TOTAL_DIFF_SUMS: '$CI_PROJECT_DIR/total-diff.sums'

  KERNEL_TAGS_DIR: '$CI_PROJECT_DIR/linux-tags/'

.cache:
  cache:
    - key: automerge-ci
      paths:
        - $CONFIG_SUMS
        - $CONFIG_DIFF_SUMS
    - key: rrcache
      paths:
        - $RERERE_SUM
        - $RERERE_DIFF_SUM
    - key: linux-tags
      paths:
        - $KERNEL_TAGS_DIR

.configs_artifacts:
  artifacts:
    paths:
      - $CONFIG_SUMS
      - $CONFIG_DIFF_SUMS
      - $TOTAL_DIFF_SUMS

.rrcache_artifacts:
  artifacts:
    paths:
      - $RERERE_SUM
      - $RERERE_DIFF_SUM
      - $TOTAL_DIFF_SUMS

.kernel_tags_artifacts:
  artifacts:
    paths:
      - $KERNEL_TAGS_DIR
      - $TOTAL_DIFF_SUMS

.trigger_artifacts:
  artifacts:
    paths:
      - $TOTAL_DIFF_SUMS

stages:
  - poll_configs
  - poll_rrcache
  - poll_kernel_tags
  - trigger_automerge

poll qualcomm/configs:
  extends:
    - .poll_configs
    - .configs_artifacts
    - .cache

poll rrcache:
  extends:
    - .poll_rrcache
    - .rrcache_artifacts
    - .cache

poll linux tags:
  extends:
    - .poll_kernel_tags
    - .kernel_tags_artifacts
    - .cache

trigger automerge:
  extends:
    - .trigger_automerge
    - .trigger_artifacts
